<template>
  <v-container>
    <v-data-table
      :headers="headers"
      :items="roles"
      sort-by="calories"
      class="elevation-1"
      :footer-props="{
        itemsPerPageText: 'Papéis por página',
      }"
    >
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-toolbar-title class="font-weight-bold primary--text">Papéis</v-toolbar-title>
          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
          <div class="navRolesOption">
            <v-btn
              v-if="userCanCreate"
              small
              color="primary"
              class="mr-4"
              elevation="0"
              @click="handleCreateDialog"
            >
              Adicionar
              <v-icon small right class="ml-3">mdi-plus</v-icon>
            </v-btn>
          </div>
        </v-toolbar>
      </template>
      <template v-slot:[`item.action`]="{ item }">
        <div class="rolesTable">
          <v-tooltip v-if="userCanEdit" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small class="mr-2" @click="handleEdit(item)">mdi-pencil</v-icon>
            </template>
            <span><b>Editar</b> papel</span>
          </v-tooltip>

          <v-tooltip v-if="userCanDelete" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleDelete(item)">mdi-delete</v-icon>
            </template>
            <span>Deletar</span>
          </v-tooltip>
        </div>
      </template>
      <template v-slot:no-data>
        <span>Nenhum papel encontrado</span>
      </template>
    </v-data-table>
    <RolesCreate />
    <RolesUpdate />
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDelete"
    />
  </v-container>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import { Management } from '../../utils/management'
import RolesCreate from '../../components/management/RolesCreate'
import RolesUpdate from '../../components/management/RolesUpdate'
import ManagementS from '../../services/management'

export default {
  name: 'Roles',
  components: {
    RolesCreate,
    RolesUpdate,
  },
  data: () => ({
    alert: {
      status: false,
      itemName: '',
      message: 'Você deseja <b>deletar</b> o papel ',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    userCanEdit: false,
    userCanDelete: false,
    userCanCreate: false,
    headers: [
      { text: 'Nome', align: 'left', sortable: false, value: 'label' },
      { text: 'Ações', align: 'right', value: 'action', sortable: false },
    ],
  }),
  computed: {
    roles() {
      return this.$store.state.user.routedEntityRoles
    },
  },
  async created() {
    await this.userCheckPrivileges('userCanEdit', 'updatePrivilege')
    await this.userCheckPrivileges('userCanDelete', 'privilegeDelete')
    await this.userCheckPrivileges('userCanCreate', 'createPrivilege')
  },
  async mounted() {
    await this.readRoles()
    let ret = await Management.readModules()
    this.UPDATE_ENTITY_MODULES(ret.data)
  },
  methods: {
    ...mapMutations('user', [
      'UPDATE_ROUTED_ENTITY_ROLES',
      'UPDATE_ROLES_CREATE',
      'UPDATE_ROLES_UPDATE',
      'UPDATE_ROLES_DELETE',
      'UPDATE_ENTITY_MODULES',
      'UPDATE_MAPPED_ACTIONS',
    ]),
    async handleCreateDialog() {
      this.UPDATE_ROLES_CREATE(true)
    },

    handleEdit(item) {
      this.UPDATE_ROLES_UPDATE({
        open: true,
        roleUpdated: {
          label: item.label,
          id: item.id,
          actions: item.actions,
        },
      })
    },

    handleDelete(item) {
      this.alert.itemName = item.label
      this.alert.status = true
      this.itemToDelete = item
    },

    async confirmDelete() {
      this.alert.status = false
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('privilegeDelete').id
      const roleId = this.itemToDelete.id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await ManagementS.removePrivilege(entityId, actionId, roleId)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Papel <b>deletado</b> com sucesso!',
            icon: 'mdi-delete-circle-outline',
            color: 'green',
          })
        }
      } catch (e) {
        console.log('catch delete role', e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      this.readRoles()
    },

    async readRoles() {
      const routedEntity = await this.$getItem('routedEntity')
      console.log(routedEntity, 'entidade ler')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readPrivilege').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await ManagementS.readPrivilege(entityId, actionId)
        this.UPDATE_ROUTED_ENTITY_ROLES(ret.data)
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async userCheckPrivileges(data, nameOfPrivilege) {
      //data = data do vue; nameOfPrivilege = nome do privilegio
      let check = false
      const routedEntity = await this.$getItem('routedEntity')
      //checa se o usuario logado na entidade pode realizar certa ação/privilégio
      routedEntity.privileges.actions.forEach((privilege) => {
        if (privilege.name == nameOfPrivilege) {
          check = true
          return
        }
      })
      this[`${data}`] = check
    },
  },
}
</script>

<style scoped>
.v-pagination__item {
  margin: 4px !important;
}
.rolesTable > .v-icon:hover {
  color: #ffc107;
}
.navRolesOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}
</style>
